<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php
	include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/divers.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Message.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Messagedesc.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Produitdesc.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Produit.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Client.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Venteprod.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Paysdesc.class.php");		
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Zone.class.php");			
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Transzone.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Modules.class.php");											
	include_once(realpath(dirname(__FILE__)) . "/Prodvirtuel2_commande.class.php");
	
	class Prodvirtuel2 extends PluginsClassiques{

		var $id;
		var $produit;
		var $nom;
		var $fichier;
		
		var $table="prodvirtuel";
		var $bddvars = array("id", "produit", "nom", "fichier");
		
		function Prodvirtuel2(){
			$this->PluginsClassiques();
		}
		
		function init(){
			$this->ajout_desc("Téléchargement", "Téléchargement", "", 1);
			
			$code = gencode(30);
			$variable = new Variable();
			
			if(! $variable->charger("repvirtuel")){
				@mkdir("../client/$code",0755);
				$variable->nom = "repvirtuel";
				$variable->valeur = $code;
				$variable->protege = 1;
				$variable->add();
				
				$mod = new Modules();
				$mod->charger("prodvirtuel");
				
				$zone = new Zone();
				$query_prodvirtuel = "select * from $zone->table";
				$resul_prodvirtuel = mysql_query($query_prodvirtuel, $zone->link);
				
				while($row = mysql_fetch_object($resul_prodvirtuel)){
					$transzone = new Transzone();
					$transzone->transport = $mod->id;
					$transzone->zone = $row->id;
					$transzone->add();					
				}
				
			}
			
			$cnx = new Cnx();
			$query_prodvirtuel = "CREATE TABLE  `prodvirtuel` (
			 `id` INT NOT NULL auto_increment,
			 `produit` INT NOT NULL ,
		 	 `nom` text NOT NULL,
		  	 `fichier` text NOT NULL,
			PRIMARY KEY (  `id` )
			) AUTO_INCREMENT=1 ;";
			$resul_prodvirtuel = mysql_query($query_prodvirtuel, $cnx->link);     

			$query_prodvirtuel = "CREATE TABLE  `prodvirtuel_commande` (
			 `id` INT NOT NULL auto_increment,
			 `prodvirtuel` INT NOT NULL ,
			 `commande` INT NOT NULL ,
			 `token` TEXT NOT NULL ,
			PRIMARY KEY (  `id` )
			) AUTO_INCREMENT=1 ;";
			$resul_prodvirtuel = mysql_query($query_prodvirtuel, $cnx->link);     

			$message = new Message();
			if($message->charger("mailprodvirtuel")) return;
			$message->nom = "mailprodvirtuel";
			$lastid = $message->add();			
			$messagedesc = new Messagedesc();
			$messagedesc->message = $lastid;
			$messagedesc->lang = 1;
			$messagedesc->titre = "Téléchargement";
			$messagedesc->chapo = "";
			$messagedesc->description = "__CLIENT_FACTPRENOM__ __CLIENT_FACTNOM__\n__CLIENT_ADRESSE1__ __CLIENT_ADRESSE2__ __CLIENT_ADRESSE3__\n__CLIENT_CPOSTAL__ __CLIENT_VILLE__\n__CLIENT_PAYS__\n\nTéléchargement des fichiers de la commande __COMMANDE_REF__ du __COMMANDE_DATE__\n\nLes articles commandés:\n<VENTEPROD>\nArticle : __VENTEPROD_TITRE__\n__VENTEPROD_TELECHARGER__\n</VENTEPROD>";
			$messagedesc->add();		
		}	

		function charger($id){
			return $this->getVars("select * from $this->table where id=\"$id\"");
		}
				
		function charger_produit($produit){
			return $this->getVars("select * from $this->table where produit=\"$produit\"");
		}

		function action(){
			if($_REQUEST['action'] == "prodvirtueldl" && $_REQUEST['token'] != ""){
				$prodcmd = new Prodvirtuel2_commande();
				if($prodcmd->charger($_REQUEST['token'])){
					$repvirtuel = new Variable();
					$repvirtuel->charger("repvirtuel");
					
					$virt = new Prodvirtuel2();
					$virt->charger($prodcmd->prodvirtuel);
					
					header("Content-type: application/force-download");
					header('Content-Disposition: attachment; filename="' . $virt->nom . '"');
					$fichier = file_get_contents("client/" . $repvirtuel->valeur . "/" . $virt->fichier);
					echo $fichier;
					exit;
				}
			}
			
		}
		
		function aprescommande($commande){
			for($i=0; $i<$_SESSION['navig']->panier->nbart; $i++){
				$tmpprod = new Prodvirtuel2();
				if($tmpprod->charger_produit($_SESSION['navig']->panier->tabarticle[$i]->produit->id)){
					$virtcmd = new Prodvirtuel2_commande();
					$virtcmd->prodvirtuel = $tmpprod->id;
					$virtcmd->commande = $commande->id;
					$virtcmd->token = gencode(30);
					$virtcmd->add();					
				}
				
			}
			
		}
		
		function boucle($texte, $args){

			$virt = 0;
			$pasvirt = 0;			
			
			for($i=0;$i<$_SESSION["navig"]->panier->nbart;$i++){
				$tmpprod = new Prodvirtuel2();
				if($tmpprod->charger_produit($_SESSION["navig"]->panier->tabarticle[$i]->produit->id))
					 $virt ++;
				else $pasvirt ++;
				
			}
						
			$modules = new Modules();
			$modules->charger("telechargement");
			
			$transport = "";
			
			if($virt && ! $pasvirt){
				$transport = $modules->id;
			}
			
			else{
				$query = "select * from $modules->table where actif=1 and type=2 and id NOT IN($modules->id)";
				$req = mysql_query($query);
				$liste = "";
				
				while($row = mysql_fetch_object($req)){
					$liste .= $row->id.",";
				}
				
				$transport = substr($liste,0,strlen($liste)-1);
			}
			
			
			$texte = str_replace("#ID",$transport,$texte);
			
			return $texte;
			
		}

		function statut($commande){
			if($commande->statut != "2")
				return;
				
			$pvcommande = new Prodvirtuel2_commande();
			$query = "select * from $pvcommande->table where commande=\"" . $commande->id . "\"";
			$resul = mysql_query($query, $pvcommande->link);	
			if(mysql_num_rows($resul) > 0){
				$message = new Message();
				$messagedesc = new Messagedesc();
			
				$message->charger("mailprodvirtuel");
				$messagedesc->charger($message->id, $_SESSION['lang']);
			
				$client = new Client();
				$client->charger_id($commande->client);
			
				$emailcontact = new Variable();
				$emailcontact->charger("emailcontact");

				$messagedesc->description =  $this->substitmail($messagedesc->description, $commande);
				mail($client->email, "$messagedesc->titre", $messagedesc->description, "From: " . $emailcontact->valeur);
			}
		
		}
		
		function confirmation($commande){
			$this->statut($commande);		
		}

		function substitmail($corps, $commande ){

		  	$jour = substr($commande->date, 8, 2);
  			$mois = substr($commande->date, 5, 2);
  			$annee = substr($commande->date, 0, 4);
  		
  			$heure = substr($commande->date, 11, 2);
  			$minute = substr($commande->date, 14, 2);
  			$seconde = substr($commande->date, 17, 2);

			$client = new Client();
			$client->charger_id($commande->client);

			$urlsite = new Variable();
			$urlsite->charger("urlsite");
			
			$corps = str_replace("__COMMANDE_REF__", $commande->ref, $corps);
			$corps = str_replace("__COMMANDE_DATE__", $jour . "/" . $mois . "/" . $annee . " " . $heure . ":" . $minute, $corps);			$corps = str_replace("__URLSITE__", $urlsite->valeur, $corps);

			
			if($client->raison == "1")
				$raison = "Madame";
			else if($client->raison == "2")
				$raison = "Mademoiselle";
			else $raison = "Monsieur";
			$pays = new Paysdesc();
			$pays->charger($client->pays);
									
			$corps = str_replace("__CLIENT_REF__", $client->ref, $corps);
			$corps = str_replace("__CLIENT_RAISON__",$raison, $corps);
			$corps = str_replace("__CLIENT_ENTREPRISE__", $client->entreprise, $corps);
			$corps = str_replace("__CLIENT_SIRET__", $client->siret, $corps);
			$corps = str_replace("__CLIENT_FACTNOM__", $client->nom, $corps);
			$corps = str_replace("__CLIENT_FACTPRENOM__", $client->prenom, $corps);
			$corps = str_replace("__CLIENT_ADRESSE1__", $client->adresse1, $corps);
			$corps = str_replace("__CLIENT_ADRESSE2__", $client->adresse2, $corps);
			$corps = str_replace("__CLIENT_ADRESSE3__", $client->adresse3, $corps);
			$corps = str_replace("__CLIENT_CPOSTAL__", $client->cpostal, $corps);
			$corps = str_replace("__CLIENT_VILLE__", $client->ville, $corps);
			$corps = str_replace("__CLIENT_PAYS__", $pays->titre, $corps);
			$corps = str_replace("__CLIENT_EMAIL__", $client->email, $corps);
			
			preg_match("`<VENTEPROD>([^<]+)</VENTEPROD>`", $corps, $cut);
			$corps = str_replace("<VENTEPROD>", "", $corps);
			$corps = str_replace("</VENTEPROD>", "", $corps);
			
			$res="";
			$temp="";
			
			$pvcommande = new Prodvirtuel2_commande();
			$query = "select * from $pvcommande->table where commande=\"" . $commande->id . "\"";
			$resul = mysql_query($query, $pvcommande->link);
			
			while($row = mysql_fetch_object($resul)){
				$tmpvirt = new Prodvirtuel2();
				$tmpvirt->charger($row->prodvirtuel);
				
				$proddesc = new Produitdesc();
				$proddesc->charger($tmpvirt->produit);

				$temp = str_replace("__VENTEPROD_TITRE__", $proddesc->titre, $cut[1]);
				$temp = str_replace("__VENTEPROD_TELECHARGER__", $urlsite->valeur . "/?action=prodvirtueldl&token=" . $row->token, $temp);
				
				$res .= $temp;
			}
			$corps = str_replace($cut[1], $res, $corps);

			return $corps;
			
		}
	
	}

?>
